//****************************************************************************
//	apci35w.pas
//
//	aPCI-A35
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/06/29
//
//****************************************************************************

unit apci35w;

interface

uses
	Windows;

{ Error Code }

const
  APCI35_SUCCESS					      = 0; { Successfully proccessed }
	APCI35_ERR_SYSTEM				      = 1; { Call GetLastError() }
	APCI35_ERR_NO_DEVICE			    = 2; { No card }
	APCI35_ERR_IN_USE				      = 3; { Device is in use }
	APCI35_ERR_INVALID_SLOT			  = 4; { Invalid slot number }
	APCI35_ERR_RESOURCE				    = 5; { Resource exhaustion }
	APCI35_ERR_INVALID_ARGUMENT		= 6; { Invalid argument }
	APCI35_ERR_NO_CREATE			    = 7; { No created device }
  APCI35_ERR_INVALID_CHANNEL		= 8; { Invalid channel }
	APCI35_ERR_INVALID_RESOLUTION =	9; { Invalid resolution }
	APCI35_ERR_TIMEOUT				    = 10;{ Conversion timeout }

{ Miscellaneous }

const
	APCI35_MAX_SLOTS	= 16;	  { Maximum number of slots }

	APCI35_SLOT_AUTO = $ffff; { default search }

{ Device ID }

const
	APCI35_BOARD_ID	 = $9035;	{ pci bus device id }
	APCI35_VENDOR_ID = $136c;	{ pci bus vendor id }
										{ our device id }
	APCI35_DEVICE_ID = (DWord(APCI35_BOARD_ID)) or (DWord(APCI35_VENDOR_ID) shl 16);

const
	APCI35_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	APCI35_DLL_NAME = 'apci35.dll';		{ DLL }

function Apci35wDllOpen: Boolean;		{ DLL [h }
function Apci35wDllClose: Boolean;	{ DLL A[h }


{ aPCI-A35 DLL,Drṽo[Wԍ擾 }
function Apci35wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaPCI-A35̎gp錾 }
function Apci35wCreate(var pwLogSlot: Word): Boolean;
{ CӂaPCI-A35̎gpJ }
function Apci35wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
  APCI35_MAX_MEM      =  9;
  APCI35_MAX_IO       = 20;
  APCI35_MAX_IRQ      =  7;
  APCI35_MAX_DMA      =  7;

type
  TAPCI35RESOURCE = record
    dwNumMemWindows:                                DWord;  { س޳(gp) }
    dwMemBase:      array [1 .. APCI35_MAX_MEM] of  DWord;  { س޳ްڽ(gp) }
    dwMemLength:    array [1 .. APCI35_MAX_MEM] of  DWord;  { س޳(gp) }
    dwMemAttrib:    array [1 .. APCI35_MAX_MEM] of  DWord;  { س޳(gp) }
    dwNumIOPorts:                                   DWord;  { I/O߰Đ }
    dwIOPortBase:   array [1 .. APCI35_MAX_IO] of   DWord;  { I/O߰ްڽ }
    dwIOPortLength: array [1 .. APCI35_MAX_IO] of   DWord;  { I/O߰Ē }
    dwNumIRQs:                                      DWord;  { IRQ(gp) }
    dwIRQRegisters: array [1 .. APCI35_MAX_IRQ] of  DWord;  { IRQؽ(gp) }
    dwIRQAttrib:    array [1 .. APCI35_MAX_IRQ] of  DWord;  { IRQؽ(gp) }
    dwNumDMAs:                                      DWord;  { DMAِ(gp) }
    dwDMALst:       array [1 .. APCI35_MAX_DMA] of  DWord;  { DMAؽ(gp) }
    dwDMAAttrib:    array [1 .. APCI35_MAX_DMA] of  DWord;  { DMAّؽ(gp) }
    dwReserved1:    array [1 .. 3] of               DWord;  { \(gp) }
  end;

PAPCI35RESOURCE = ^TAPCI35RESOURCE;


{ \[X擾 }
function Apci35wGetResource(wLogSlot: Word; pres: PAPCI35RESOURCE): Boolean;

{ [^XCb`̒l擾 }
function Apci35wGetSwitchValue(wLogSlot: Word; var pdwSwitchValue: DWord): Boolean;


type
  TAPCI35PARA = record
    dwSamplingChannel: DWord;   { TvOs`li1`8j }
    dwResolution:      DWord;   { \i 8 = 8 [bit] / 12 = 12 [bit] j }
  end;

PAPCI35PARA = ^TAPCI35PARA;

{ A/DTvO̎s }
function Apci35wStartSampling(wLogSlot: Word; pcpara: PAPCI35PARA; var pwSamplingData: Word): Boolean;


{ Cӂ̃|[gf[^ }
function Apci35wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Apci35wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;


{ aPCI-A35̃G[R[h }
function Apci35wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TApci35GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TApci35Create = function(var pwLogSlot: Word): Bool; stdcall;
	TApci35Close = function(wLogSlot:	Word): Bool; stdcall;
	TApci35GetResource = function(wLogSlot: Word; pres: PAPCI35RESOURCE): Bool; stdcall;
  TApci35GetSwitchValue = function(wLogSlot: Word; var pdwSwitchValue: DWord): Bool; stdcall;
  TApci35StartSampling = function(wLogSlot: Word; pcpara: PAPCI35PARA; var pwSamplingData: Word): Bool; stdcall;
	TApci35InPort = function(wLogSlot: Word; var pbInValue: Byte): Bool; stdcall;
	TApci35OutPort = function(wLogSlot: Word; bOutValue: Byte): Bool; stdcall;
	TApci35GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Apci35wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pApci35GetVersion: TApci35GetVersion;
	pApci35Create: TApci35Create;
	pApci35Close: TApci35Close;
	pApci35GetResource: TApci35GetResource;
  pApci35GetSwitchValue: TApci35GetSwitchValue;
  pApci35StartSampling: TApci35StartSampling;
	pApci35InPort: TApci35InPort;
	pApci35OutPort: TApci35OutPort;
	pApci35GetLastError: TApci35GetLastError;


//****************************************************************************
// 		apci35.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Apci35wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(APCI35_DLL_NAME);
	if hDLL = 0 then Exit;

	if Apci35wGetDllExportFunc = False then
	begin
		Apci35wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		apci35.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Apci35wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aPCI-A35 DLL,Vxd̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drvo[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Apci35wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aPCI-A35̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
// ߂l  True
//				s False
//****************************************************************************
function Apci35wCreate(var pwLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35Create(pwLogSlot);
end;

//****************************************************************************
// 		aPCI-A35̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Apci35wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres     \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Apci35wGetResource(wLogSlot: Word; pres: PAPCI35RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35GetResource(wLogSlot, pres);
end;


//****************************************************************************
// 	  [^XCb`̒l擾
// 	  wLogSlot		   ׂfoCX
//		    pdwSwitchValue [^XCb`̒l
// ߂l  True
//		    s False
//****************************************************************************
function Apci35wGetSwitchValue(wLogSlot: Word; var pdwSwitchValue: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35GetSwitchValue(wLogSlot, pdwSwitchValue);
end;

//****************************************************************************
// 	  A/DTvO̎s
// 	  wLogSlot		   TvOfoCX
//		    pcpara		     TvOp[^
//		    pwSamplingData TvOf[^
// ߂l  True
//		    s False
//****************************************************************************
function Apci35wStartSampling(wLogSlot: Word; pcpara: PAPCI35PARA; var pwSamplingData: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35StartSampling(wLogSlot, pcpara, pwSamplingData);
end;

//****************************************************************************
// 		Cӂ̃|[gf[^
// 		wLogSlot	͂foCX
//				pbInValue ̓f[^i[
// ߂l  True
//				s False
//****************************************************************************
function Apci35wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35InPort(wLogSlot, pbInValue);
end;

//****************************************************************************
// 		Cӂ̃|[gփf[^o
// 		wLogSlot	o͂foCX
//				bOutValue o͂f[^
// ߂l  True
//				s False
//****************************************************************************
function Apci35wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci35OutPort(wLogSlot, bOutValue);
end;

//****************************************************************************
// 		aPCI-A35̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Apci35wGetLastError(wLogSlot: Word): DWord;
begin
	Result := APCI35_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pApci35GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Apci35wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Apci35GetVersion ̃AhX擾
	pApci35GetVersion := GetProcAddress(hDLL, 'Apci35GetVersion');
	if @pApci35GetVersion = nil then Exit;

	// Apci35Create ̃AhX擾
	pApci35Create := GetProcAddress(hDLL, 'Apci35Create');
	if @pApci35Create = nil then Exit;

	// Apci35Close ̃AhX擾
	pApci35Close := GetProcAddress(hDLL, 'Apci35Close');
	if @pApci35Close = nil then Exit;

	// Apci35GetResource ̃AhX擾
	pApci35GetResource := GetProcAddress(hDLL, 'Apci35GetResource');
	if @pApci35GetResource = nil then Exit;

  // Apci35GetSwitchValue ̃AhX擾
  pApci35GetSwitchValue := GetProcAddress(hDLL, 'Apci35GetSwitchValue');
	if @pApci35GetSwitchValue = nil then Exit;

  // Apci35StartSampling ̃AhX擾
  pApci35StartSampling := GetProcAddress(hDLL, 'Apci35StartSampling');
	if @pApci35StartSampling = nil then Exit;

	// Apci35InPort ̃AhX擾
	pApci35InPort := GetProcAddress(hDLL, 'Apci35InPort');
	if @pApci35InPort = nil then Exit;

	// Apci35OutPort ̃AhX擾
	pApci35OutPort := GetProcAddress(hDLL, 'Apci35OutPort');
	if @pApci35OutPort = nil then Exit;

	// Apci35GetLastError ̃AhX擾
	pApci35GetLastError := GetProcAddress(hDLL, 'Apci35GetLastError');
	if @pApci35GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

