'****************************************************************************
'*  apci35w.vb
'*
'*  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'****************************************************************************
Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Apci35w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    ' Error Code
    Public Const SUCCESS As Integer = 0                 ' Successfully proccessed
    Public Const ERR_SYSTEM As Integer = 1              ' Call GetLastError()
    Public Const ERR_NO_DEVICE As Integer = 2           ' No card
    Public Const ERR_IN_USE As Integer = 3              ' Device is in use
    Public Const ERR_INVALID_SLOT As Integer = 4        ' Invalid slot number
    Public Const ERR_RESOURCE As Integer = 5            ' Resource exhaustion
    Public Const ERR_INVALID_ARGUMENT As Integer = 6    ' Invalid argument
    Public Const ERR_NO_CREATE As Integer = 7           ' No created device
    Public Const ERR_INVALID_CHANNEL As Integer = 8     ' Invalid channel
    Public Const ERR_INVALID_RESOLUTION As Integer = 9  ' Invalid resolution
    Public Const ERR_TIMEOUT As Integer = 10            ' Conversion timeout
    Public Const ERR_WRAPDLL As Integer = -1            ' bp[֐G[

    ' Miscellaneous
    Public Const MAX_SLOTS As Integer = 16              ' Maximum number of slots

    Public Const SLOT_AUTO As Short= &HFFFFS            ' default search

    ' Resource infomation structure
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1    ' MAX_MEM_REGISTERS
    Public Const MAX_IO As Integer = 20 - 1    ' MAX_IO_PORTS
    Public Const MAX_IRQ As Integer = 7 - 1    ' MAX_IRQS
    Public Const MAX_DMA As Integer = 7 - 1    ' MAX_DMA_CHANNELS
    Public Const MAX_RSV As Integer = 3 - 1

    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    ' Sampling parameter structure
    Structure SampleParams
        Dim dwSamplingChannel As Integer   'TvOs`li1`8j
        Dim dwResolution As Integer        '\i 8 = 8 [bit] / 12 = 12 [bit] j

        Dim dwChFirst As Integer    ' TvOJn`l(0 ` 7)
        Dim dwChLast As Integer     ' TvOI`l(0 ` 7)
        Dim cwBuffer As Integer     ' obt@TCYi[hPʁj
        Dim dwTimer As Integer      ' ^C}l(00H ` 3FH)
        Dim dwMode As Integer       ' 샂[h(1 ` 6)
    End Structure

    ' API
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDriverVersion As Integer) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35Create(ByRef pwLogSlot As Short) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35Close(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35GetResource(ByVal wLogSlot As Short, ByRef pres As Resource) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35StartSampling(ByVal wLogSlot As Short, ByRef pcpara As SampleParams, ByRef pwSamplingData As Short) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35InPort(ByVal wLogSlot As Short, ByRef pbInValue As Byte) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35OutPort(ByVal wLogSlot As Short, ByVal bOutValue As Byte) As Boolean
    End Function
    <DllImport("apci35.dll")> _
    Public Shared Function Apci35GetLastError(ByVal wLogSlot As Short) As Long
    End Function

    '*****************************************************************************
    '*    aPCI-A35 DLL,Drṽo[Wԍ擾
    '*    pdwDllVer DLLo[Wԍi[
    '*        pdwDrvVer Drvo[Wԍi[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean

        Try
            GetVersion = Apci35GetVersion(pdwDllVer, pdwDrvVer)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try

    End Function

    '*****************************************************************************
    '*    aPCI-A35̔Cӂ̃foCX̎gp錾
    '*    pwLogSlot  gpfoCXi[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Create(ByRef pwLogSlot As Short) As Boolean

        Try
            Create = Apci35Create(pwLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try

    End Function

    '*****************************************************************************
    '*    aPCI-A35̔Cӂ̃foCX̎gpJ
    '*    wLogSlot gpfoCX
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Close(ByVal wLogSlot As Short) As Boolean

        Try
            Close = Apci35Close(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try

    End Function

    '*****************************************************************************
    '*    wfoCX̃\[X擾
    '*    wLogSlot ׂfoCX
    '*        pres     \[Xi[\
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetResource(ByVal wLogSlot As Short, ByRef pres As Resource) As Boolean

        Try
            GetResource = Apci35GetResource(wLogSlot, pres)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try

    End Function

    '*****************************************************************************
    '*    [^XCb`̒l擾
    '*    wLogSlot       ׂfoCX
    '*        pdwSwitchValue [^XCb`̒l
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetSwitchValue(ByRef wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean

        Try
            GetSwitchValue = Apci35GetSwitchValue(wLogSlot, pdwSwitchValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSwitchValue = False
        End Try

    End Function

    '*****************************************************************************
    '*    A/DTvO̎s
    '*    wLogSlot       TvOfoCX
    '*        pcpara         TvOp[^
    '*        pwSamplingData TvOf[^
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function StartSampling(ByVal wLogSlot As Short, ByRef pcpara As SampleParams, ByRef pwSamplingData As Short) As Boolean

        Try
            StartSampling = Apci35StartSampling(wLogSlot, pcpara, pwSamplingData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            StartSampling = False
        End Try

    End Function

    '*****************************************************************************
    '*    Cӂ̃|[gf[^
    '*    wLogSlot  ͂foCX
    '*        pbInValue ̓f[^i[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function InPort(ByVal wLogSlot As Short, ByRef pbInValue As Byte) As Boolean

        Try
            InPort = Apci35InPort(wLogSlot, pbInValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            InPort = False
        End Try

    End Function

    '*****************************************************************************
    '*    Cӂ̃|[gփf[^o
    '*    wLogSlot  o͂foCX
    '*        bOutValue o͂f[^
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function OutPort(ByVal wLogSlot As Short, ByVal bOutValue As Byte) As Boolean

        Try
            OutPort = Apci35OutPort(wLogSlot, bOutValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            OutPort = False
        End Try

    End Function

    '*****************************************************************************
    '*    aPCI-A35̃G[R[h
    '*    wLogSlot  G[foCX
    '* ߂l G[R[h
    '*****************************************************************************
    Public Function GetLastError(ByVal wLogSlot As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Apci35GetLastError(wLogSlot)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A35 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function

End Class
