/******************************************************************************/
/*	apci35s.cs																  */
/*																			  */
/*	aPCI-A35															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/

//=========================================================================
// rh IvV̐ݒ菇܂B
//
// 1.vWFNg [vpeB] y[WJ܂B
// 2.[rh] vpeB y[WNbN܂B
// 3.[AZ[t R[h̋] `FbN {bNXIɂ܂B
//=========================================================================

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SampleA35
{
    public partial class Apci35s : Form
    {
        static Apci35w A35w;

        public Apci35s()
        {
            InitializeComponent();
        }

        private unsafe void Apci35s_Load(object sender, EventArgs e)
        {
            int dwDllVer, dwDrvVer;
            bool bResult;			// 
            short wLogSlot;			// foCXi[
            Byte b;
            Apci35w.Resource ri;	// \[X
            int dwSwitchValue;		// [^XCb`̒l
            Apci35w.SampleParams param;	// TvOp[^
            short wSmpData;			// TvOf[^
            String szbuf;
            int i;

            A35w  = new Apci35w();
            param = new Apci35w.SampleParams();
            ri    = new Apci35w.Resource();
            ri.dwMemBase        = new int[Apci35w.MAX_MEM];
            ri.dwMemLength      = new int[Apci35w.MAX_MEM];
            ri.dwMemAttrib      = new int[Apci35w.MAX_MEM];
            ri.dwIOPortBase     = new int[Apci35w.MAX_IO];
            ri.dwIOPortLength   = new int[Apci35w.MAX_IO];
            ri.dwIRQRegisters   = new int[Apci35w.MAX_IRQ];
            ri.dwIRQAttrib      = new int[Apci35w.MAX_IRQ];
            ri.dwDMALst         = new int[Apci35w.MAX_DMA];
            ri.dwDMAAttrib      = new int[Apci35w.MAX_DMA];
            ri.dwReserved1      = new int[Apci35w.MAX_RSV];

            // 
            ri.dwNumMemWindows = 0;
            for (i = 0; i < Apci35w.MAX_MEM; i++)
            {
                ri.dwMemBase[i] = 0;
                ri.dwMemLength[i] = 0;
                ri.dwMemAttrib[i] = 0;
            }
            ri.dwNumIOPorts = 0;
            for (i = 0; i < Apci35w.MAX_IO; i++)
            {
                ri.dwIOPortBase[i] = 0;
                ri.dwIOPortLength[i] = 0;
            }
            ri.dwNumIRQs = 0;
            for (i = 0; i < Apci35w.MAX_IRQ; i++)
            {
                ri.dwIRQRegisters[i] = 0;
                ri.dwIRQAttrib[i] = 0;
            }
            ri.dwNumDMAs = 0;
            for (i = 0; i < Apci35w.MAX_DMA; i++)
            {
                ri.dwDMALst[i] = 0;
                ri.dwDMAAttrib[i] = 0;
            }
            for (i = 0; i < Apci35w.MAX_RSV; i++)
                ri.dwReserved1[i] = 0;

            /*---------------------------------------------------------------------------*/
            // o[Wԍ\
            // aPCI-A35 DLL,Drṽo[Wԍ擾
            if (A35w.GetVersion(&dwDllVer, &dwDrvVer) == false)
            {
                ErrorMessage(Apci35w.SLOT_AUTO);
                return;
            }
            szbuf = String.Concat("GetVersion\n",
                                    String.Format("DLL: 0x{0:x8}\n", dwDllVer),
                                    String.Format("DRV: 0x{0:x8}", dwDrvVer));
            ResultMessage(szbuf);

            /*---------------------------------------------------------------------------*/
            // aPCI-A35̎gp錾
            wLogSlot = Apci35w.SLOT_AUTO;		// gp̃foCXT܂B
            bResult = A35w.Create(&wLogSlot);	// ꍇA̎̃foCXi[܂B
            if (bResult == false)
            {				// foCX܂B
                ErrorMessage(Apci35w.SLOT_AUTO);
                return;
            }
            szbuf = String.Concat("Created\n\n",
                                    String.Format("LogSlot: {0}", wLogSlot));
            ResultMessage(szbuf);

            /*---------------------------------------------------------------------------*/
            // \[X擾
            if (A35w.GetResource(wLogSlot, ref ri) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }

            /*---------------------------------------------------------------------------*/
            // [^XCb`̒l擾
            if (A35w.GetSwitchValue(wLogSlot, &dwSwitchValue) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            szbuf = String.Concat(String.Format("IO Address : 0x{0:x4} - 0x{1:x4}\n",
                                                    ri.dwIOPortBase[0],
                                                    ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1),
                                    String.Format("Switch    : 0x{0:x}",
                                                    dwSwitchValue));
            ResultMessage(szbuf);

            /*---------------------------------------------------------------------------*/
            // TvO
            param.dwSamplingChannel = 1;	// TvOs`l (1`8)
            param.dwResolution = 12;		// \(8 or 12 bits)
            if (A35w.StartSampling(wLogSlot, ref param, &wSmpData) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            szbuf = String.Concat("TvOf[^\n",
                                    String.Format("Data: {0:x3}h", wSmpData));
            ResultMessage(szbuf);

            /*---------------------------------------------------------------------------*/
            // Cӂ̃f[^o
            b = 0xaa;
            if (A35w.OutPort(wLogSlot, b) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            szbuf = String.Concat("f[^o\n",
                                    String.Format("Out Data: {0:x2}h", b));
            ResultMessage(szbuf);

            /*---------------------------------------------------------------------------*/
            // f[^ǂݍ
            b = 0x00;
            if (A35w.InPort(wLogSlot, &b) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            szbuf = String.Concat("f[^\n",
                                    String.Format("In Data: {0:x2}h", b));
            ResultMessage(szbuf);

            /*---------------------------------------------------------------------------*/
            // aPCI-A35̎gpJ
            if (A35w.Close(wLogSlot) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            ResultMessage("Closed");
            this.Close();
        }

        // ʂ\
        private void ResultMessage(string buf)
        {
            MessageBox.Show(buf, this.Text,
                            MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        // װүނ\
        private void ErrorMessage(short wLogSlot)
        {
            int dwRes = A35w.GetLastError(wLogSlot);
            string buf;

            switch (dwRes)
            {
                case Apci35w.ERR_WRAPDLL:
                case Apci35w.ERR_SYSTEM:
                    dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error();
                    buf = String.Concat("System error\n\n",
                                        String.Format("Error code: 0x{0:X8}", dwRes));
                    break;

                default:
                    buf = String.Concat("aPCI-A35 error\n\n",
                                        String.Format("Error code: 0x{0:X8}", dwRes));
                    break;
            }
            MessageBox.Show(buf, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Stop);
        }

    }
}