Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       apci35.bas
'
'       aPCI-A35 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' Error Code

Global Const APCI35_SUCCESS = 0                  ' Successfully proccessed
Global Const APCI35_ERR_SYSTEM = 1               ' Call GetLastError()
Global Const APCI35_ERR_NO_DEVICE = 2            ' No card
Global Const APCI35_ERR_IN_USE = 3               ' Device is in use
Global Const APCI35_ERR_INVALID_SLOT = 4         ' Invalid slot number
Global Const APCI35_ERR_RESOURCE = 5             ' Resource exhaustion
Global Const APCI35_ERR_INVALID_ARGUMENT = 6     ' Invalid argument
Global Const APCI35_ERR_NO_CREATE = 7            ' No created device
Global Const APCI35_ERR_INVALID_CHANNEL = 8      ' Invalid channel
Global Const APCI35_ERR_INVALID_RESOLUTION = 9   ' Invalid resolution
Global Const APCI35_ERR_TIMEOUT = 10             ' Conversion timeout

' Miscellaneous

Global Const APCI35_MAX_SLOTS = 16             ' Maximum number of slots

Global Const APCI35_SLOT_AUTO = &HFFFF         ' default search

' Device ID

Global Const APCI35_BOARD_ID = &H9035          ' pci bus device id
Global Const APCI35_VENDOR_ID = &H136C         ' pci bus vendor id
                                        
Global Const APCI35_DEVICE_ID = &H136C9035     ' our device id

' Resource infomation structure

Global Const APCI35_MAX_MEM = 9
Global Const APCI35_MAX_IO = 20
Global Const APCI35_MAX_IRQ = 7
Global Const APCI35_MAX_DMA = 7

Type APCI35RESOURCE
    dwNumMemWindows As Long                     ' س޳       gp
    dwMemBase(1 To APCI35_MAX_MEM) As Long      ' س޳ްڽgp
    dwMemLength(1 To APCI35_MAX_MEM) As Long    ' س޳       gp
    dwMemAttrib(1 To APCI35_MAX_MEM) As Long    ' س޳     gp
    dwNumIOPorts As Long                        ' I/O߰Đ
    dwIOPortBase(1 To APCI35_MAX_IO) As Long    ' I/O߰ްڽ
    dwIOPortLength(1 To APCI35_MAX_IO) As Long  ' I/O߰Ē
    dwNumIRQs As Long                           ' IRQ             gp
    dwIRQRegisters(1 To APCI35_MAX_IRQ) As Long ' IRQؽ            gp
    dwIRQAttrib(1 To APCI35_MAX_IRQ) As Long    ' IRQؽ        gp
    dwNumDMAs As Long                           ' DMAِ         gp
    dwDMALst(1 To APCI35_MAX_DMA) As Long       ' DMAؽ        gp
    dwDMAAttrib(1 To APCI35_MAX_DMA) As Long    ' DMAّؽ    gp
    dwReserved1(1 To 3) As Long                 ' \              gp
End Type

' Sampling parameter structure

Type APCI35PARA
    dwSamplingChannel As Long   'TvOs`li1`8j
    dwResolution As Long        '\i 8 = 8 [bit] / 12 = 12 [bit] j
End Type

Declare Function Apci35GetVersion Lib "apci35" (pdwDllVersion As Long, pdwDriverVersion As Long) As Long
Declare Function Apci35Create Lib "apci35" (pwLogSlot As Integer) As Long
Declare Function Apci35Close Lib "apci35" (ByVal wLogSlot As Integer) As Long
Declare Function Apci35GetResource Lib "apci35" (ByVal wLogSlot As Integer, pres As APCI35RESOURCE) As Long
Declare Function Apci35GetSwitchValue Lib "apci35" (ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Long
Declare Function Apci35StartSampling Lib "apci35" (ByVal wLogSlot As Integer, pcpara As APCI35PARA, pwSamplingData As Integer) As Long
Declare Function Apci35InPort Lib "apci35" (ByVal wLogSlot As Integer, pbInValue As Byte) As Long
Declare Function Apci35OutPort Lib "apci35" (ByVal wLogSlot As Integer, ByVal bOutValue As Byte) As Long
Declare Function Apci35GetLastError Lib "apci35" (ByVal wLogSlot As Integer) As Long

