Attribute VB_Name = "Sample"
'*****************************************************************************
'* apci35s.bas                                                               *
'*                                                                           *
'* aPCI-A35                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szTitle = "Sample"
Private Const szA35 = "aPCI-A35"
Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()
    
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim b As Byte
    Dim ri As APCI35RESOURCE            ' \[X
    Dim dwSwitchValue As Long           ' [^XCb`̒l
    Dim param As APCI35PARA             ' TvOp[^
    Dim wSmpData As Integer             ' TvOf[^

'---------------------------------------------------------------------------
    ' apci35.dll ̎gp錾
    If Apci35wDllOpen() = False Then
        ErrorMessage (APCI35_SLOT_AUTO)
        Exit Sub                ' apci35.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Apci35wGetVersion(dwDllVer, dwDrvVer) = False Then ' aPCI-A35DLL,Drṽo[Wԍ擾
        ErrorMessage (APCI35_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-A35̎gp錾
    wLogSlot = APCI35_SLOT_AUTO     ' gp̃foCXT܂B
    
    ' ꍇA̎̃foCXi[܂B
    bResult = Apci35wCreate(wLogSlot)
                                             
    If bResult = False Then         ' foCX܂B
        ErrorMessage (APCI35_SLOT_AUTO)
        Exit Sub
    End If
    
    strbuf = "aPCI-A35 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Apci35wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

'---------------------------------------------------------------------------
    ' [^XCb`̒l擾
    If Apci35wGetSwitchValue(wLogSlot, dwSwitchValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szA35 + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "SwitchValue: &H" + Hex(dwSwitchValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvO
    param.dwSamplingChannel = 1     ' TvOs`l (1`8)
    param.dwResolution = 12         ' \(8 or 12 bits)

    If Apci35wStartSampling(wLogSlot, param, wSmpData) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "TvOf[^" + Chr(10) + _
             "Data: &H" + Hex(wSmpData)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Cӂ̃f[^o
    ' &HAA -> 10101010
    b = &HAA

    If Apci35wOutPort(wLogSlot, b) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "f[^o" + Chr(10) + _
             "Out Data: &H" + Hex(b)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' f[^ǂݍ
    b = &H0
    
    If Apci35wInPort(wLogSlot, b) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "f[^" + Chr(10) + _
             "In Data: &H" + Hex(b)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-A35̎gpJ
    If Apci35wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aPCI-A35 Closed")

'---------------------------------------------------------------------------
    ' apci35.dll ̎gpJ
    If Apci35wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' apci35.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Integer
    Dim szbuf As String
    
    dwRes = Apci35wGetLastError(wLogSlot)

    Select Case dwRes
    Case APCI35_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())
    
    Case APCI35_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else
        szbuf = "aPCI-A35 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
