/******************************************************************************/
/*	apci35s.c																  */
/*																			  */
/*	aPCI-A35															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/06/29															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "apci35w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szA35[] = _T("aPCI-A35");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	BYTE  b;
	APCI35RESOURCE ri;				// \[X
	DWORD		   dwSwitchValue;	// [^XCb`̒l
	APCI35PARA	   param;			// TvOp[^
	WORD		   wSmpData;		// TvOf[^

/*---------------------------------------------------------------------------*/
	// apci35.dll ̎gp錾
	if (Apci35wDllOpen() == FALSE)
	{
		ErrorMessage(APCI35_SLOT_AUTO);
		return 1;			// apci35.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aPCI-A35 DLL,Drṽo[Wԍ擾
	if (Apci35wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(APCI35_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aPCI-A35̎gp錾
	wLogSlot = APCI35_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Apci35wCreate(&wLogSlot);	// ꍇA̎̃foCXi[܂B

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(APCI35_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aPCI-A35 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Apci35wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

/*---------------------------------------------------------------------------*/
	// [^XCb`̒l擾
	if (Apci35wGetSwitchValue(wLogSlot, &dwSwitchValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n")
					_T("SwitchValue: %xh"),
					szA35,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					dwSwitchValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvO
	param.dwSamplingChannel = 1;	// TvOs`l (1`8)
	param.dwResolution = 12;		// \(8 or 12 bits)

	if (Apci35wStartSampling(wLogSlot, &param, &wSmpData) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("TvOf[^\n")
					_T("Data: %03xh"),
					 wSmpData);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// Cӂ̃f[^o
	// o̓f[^ AAh
	b = (BYTE)0xAA;

	if (Apci35wOutPort(wLogSlot, b) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("f[^o\n")
					_T("Out Data: %02xh"),
					 b);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// f[^ǂݍ
	b = (BYTE)0x00;

	if (Apci35wInPort(wLogSlot, &b) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("f[^\n")
					_T("In Data: %02xh"),
					 b);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aPCI-A35̎gpJ
	if (Apci35wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-A35 Closed"));

/*---------------------------------------------------------------------------*/
	// apci35.dll ̎gpJ
	if (Apci35wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// apci35.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci35wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case APCI35_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;

		case APCI35_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aPCI-A35 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
