/*****************************************************************************/
/*	apci35w.c																 */
/*																			 */
/*	aPCI-A35															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/03/05															 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "apci35w.h"	// aPCI-A35

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Apci35wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pApci35GetVersion;
static FARPROC pApci35Create;
static FARPROC pApci35Close;
static FARPROC pApci35GetResource;
static FARPROC pApci35GetSwitchValue;
static FARPROC pApci35StartSampling;
static FARPROC pApci35InPort;
static FARPROC pApci35OutPort;
static FARPROC pApci35GetLastError;


/*****************************************************************************/
/* 	  apci35.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(APCI35_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Apci35wGetDllExportFunc() == FALSE)
	{
		Apci35wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  apci35.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}

	return FALSE;
}

/*****************************************************************************/
/* 	  aPCI-A35 DLL,Vxd̃o[Wԍ擾								 */
/* 	  pdwDllVer DLL	  o[Wԍi[AhX					 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aPCI-A35̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot	 gpfoCXi[AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wCreate(PWORD pwLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35Create)(pwLogSlot);
}

/*****************************************************************************/
/* 	  aPCI-A35̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wGetResource(WORD wLogSlot, PAPCI35R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  [^XCb`̒l擾										 */
/* 	  wLogSlot		 ׂfoCX										 */
/*		  pdwSwitchValue [^XCb`̒l								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35GetSwitchValue)(wLogSlot, pdwSwitchValue);
}

/*****************************************************************************/
/* 	  A/DTvO̎s												 */
/* 	  wLogSlot		 TvOfoCX							 */
/*		  pcpara		 TvOp[^								 */
/*		  pwSamplingData TvOf[^									 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wStartSampling(WORD wLogSlot, PAPCI35P pcpara, PWORD pwSamplingData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35StartSampling)(wLogSlot, pcpara, pwSamplingData);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gf[^										 */
/* 	  wLogSlot	͂foCX										 */
/*		  pbInValue ̓f[^i[AhX							 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wInPort(WORD wLogSlot, PBYTE pbInValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35InPort)(wLogSlot, pbInValue);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gփf[^o										 */
/* 	  wLogSlot	o͂foCX										 */
/*		  bOutValue o͂f[^											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci35wOutPort(WORD wLogSlot, BYTE bOutValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci35OutPort)(wLogSlot, bOutValue);
}

/*****************************************************************************/
/* 	  aPCI-A35̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Apci35wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return APCI35_ERR_WRAPDLL;

	return (*pApci35GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Apci35wGetDllExportFunc()
{
	// Apci35GetVersion ̃AhX擾
	pApci35GetVersion = GetProcAddress(hDLL, _T("Apci35GetVersion"));
	if (pApci35GetVersion == NULL)
		return FALSE;

	// Apci35Create ̃AhX擾
	pApci35Create = GetProcAddress(hDLL, _T("Apci35Create"));
	if (pApci35Create == NULL)
		return FALSE;

	// Apci35Close ̃AhX擾
	pApci35Close = GetProcAddress(hDLL, _T("Apci35Close"));
	if (pApci35Close == NULL)
		return FALSE;

	// Apci35GetResource ̃AhX擾
	pApci35GetResource = GetProcAddress(hDLL, _T("Apci35GetResource"));
	if (pApci35GetResource == NULL)
		return FALSE;

	// Apci35GetSwitchValue ̃AhX擾
	pApci35GetSwitchValue = GetProcAddress(hDLL, _T("Apci35GetSwitchValue"));
	if (pApci35GetSwitchValue == NULL)
		return FALSE;

	// Apci35StartSampling ̃AhX擾
	pApci35StartSampling = GetProcAddress(hDLL, _T("Apci35StartSampling"));
	if (pApci35StartSampling == NULL)
		return FALSE;

	// Apci35InPort ̃AhX擾
	pApci35InPort = GetProcAddress(hDLL, _T("Apci35InPort"));
	if (pApci35InPort == NULL)
		return FALSE;

	// Apci35OutPort ̃AhX擾
	pApci35OutPort = GetProcAddress(hDLL, _T("Apci35OutPort"));
	if (pApci35OutPort == NULL)
		return FALSE;

	// Apci35GetLastError ̃AhX擾
	pApci35GetLastError = GetProcAddress(hDLL, _T("Apci35GetLastError"));
	if (pApci35GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
